(ns jambda.styles
  (:require
   [spade.core :as spade]
   [garden.selectors :as s])
  (:require-macros
    [garden.def :refer [defcssfn]]
    [spade.core   :refer [defglobal defclass]]))

(def gruvbox-colors
  {:dark0-hard       :#1d2021
   :dark0            :#282828
   :dark0-soft       :#32302f
   :dark1            :#3c3836
   :dark2            :#504945
   :dark3            :#665c54
   :dark4            :#7c6f64

   :gray-245         :#928374
   :gray-244         :#928374

   :light0-hard      :#f9f5d7
   :light0           :#fbf1c7
   :light0-soft      :#f2e5bc
   :light1           :#ebdbb2
   :light2           :#d5c4a1
   :light3           :#bdae93
   :light4           :#a89984

   :bright-red       :#fb4934
   :bright-green     :#b8bb26
   :bright-yellow    :#fabd2f
   :bright-blue      :#83a598
   :bright-purple    :#d3869b
   :bright-aqua      :#8ec07c
   :bright-orange    :#fe8019

   :neutral-red      :#cc241d
   :neutral-green    :#98971a
   :neutral-yellow   :#d79921
   :neutral-blue     :#458588
   :neutral-purple   :#b16286
   :neutral-aqua     :#689d6a
   :neutral-orange   :#d65d0e

   :faded-red        :#9d0006
   :faded-green      :#79740e
   :faded-yellow     :#b57614
   :faded-blue       :#076678
   :faded-purple     :#8f3f71
   :faded-aqua       :#427b58
   :faded-orange     :#af3a03})

; TODO: put this in an atom and put it in the appstate
(def colorscheme gruvbox-colors)

(defcssfn calc)

(def mono-font ["Source Code Pro" "monospace"])

(defn- content-after [x] [(s/& s/after) {:content (str "'" x "'")}])
(defn- content-before [x] [(s/& s/before) {:content (str "'" x "'")}])

(defglobal defaults
  [:body
   {
    :color (colorscheme :dark1)
    :font-family mono-font
    :font-size :100%
    :line-height :1.2rem
    :background-color    (colorscheme :light0-hard)}])

(defclass screen []
    {:display :flex
     :justify-content :center})

(defclass main-panel []
    {:width :88ch})

(defclass footer []
    {:font-size :0.75rem}
    [(s/not (s/last-child)) {} (content-after " · ")])

(def title-style
  [:h1 {:margin-top :0.2rem
        :margin-bottom :0.2rem
        :background-color (colorscheme :dark1)
        :color (colorscheme :light0-soft)
        :padding :0.2rem
        ; letters that hang down touch the lower edge of the box without this
        :padding-bottom :0.4rem}])
